//+------------------------------------------------------------------+
//|                          Bollinger bands multiple deviations.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 LimeGreen
#property indicator_color2 DimGray
#property indicator_color3 Orange
#property indicator_color4 LimeGreen
#property indicator_color5 DimGray
#property indicator_color6 Orange
#property indicator_style2 STYLE_DOT
#property indicator_style5 STYLE_DOT

//
//
//
//
//

extern int    BandsLength1    =    20;
extern double BandsDeviation1 =     2; 
extern int    BandsLength2    =   100;
extern double BandsDeviation2 =     2; 

//
//
//
//
//

double MaBuffer1[];
double UpperBand1[];
double LowerBand1[];
double MaBuffer2[];
double UpperBand2[];
double LowerBand2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0,UpperBand1);
   SetIndexBuffer(1,MaBuffer1);
   SetIndexBuffer(2,LowerBand1);
   SetIndexBuffer(3,UpperBand2);
   SetIndexBuffer(4,MaBuffer2);
   SetIndexBuffer(5,LowerBand2);
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //

   for (int i=limit;i>=0;i--)
      {
         double deviation1   = iStdDev(NULL,0,BandsLength1,0,MODE_SMA,PRICE_CLOSE,i);
         double deviation2   = iStdDev(NULL,0,BandsLength1,0,MODE_SMA,PRICE_CLOSE,i);
               MaBuffer1[i]  = iMA(NULL,0,BandsLength1,0,MODE_SMA,PRICE_CLOSE,i);
               MaBuffer2[i]  = iMA(NULL,0,BandsLength2,0,MODE_SMA,PRICE_CLOSE,i);
               UpperBand1[i] = MaBuffer1[i]+BandsDeviation1*deviation1;
               LowerBand1[i] = MaBuffer1[i]-BandsDeviation1*deviation1;
               UpperBand2[i] = MaBuffer2[i]+BandsDeviation2*deviation2;
               LowerBand2[i] = MaBuffer2[i]-BandsDeviation2*deviation2;
      }               
   return(0);
}